;gray2.inc
;copyright 1999 joshua seagoe

;on key will kill grayscale and exit to homescreen
;(in case the program crashes)

;memory areas used outside of program:
;$f000-$f3ff light image
;$f400-$f500 interrupt table =$f5
;$f501-$f507 keyboard scan
;$f508-$fc09 incremented on each interrupt
;$f5f5-$f647 interrupt routine
;$fc00-$ffff dark image

;      bit 7     6     5     4     3     2     1     0
;$f507  [ MORE  EXIT  2nd   F1    F2    F3    F4    F5   ]
;$f506  [ ALPHA GRAPH LOG   LN    x^2   ,     STO   --   ]
;$f505  [ x-var TABLE SIN   EE    7     4     1     0    ]
;$f504  [ DEL   PRGM  COS   (     8     5     2     .    ]
;$f503  [ --   CUSTOM TAN   )     9     6     3     (-)  ]
;$f502  [ --   CLEAR  ^     /     *     -     +    ENTER ]
;$f501  [ --    --    --    --    UP    RIGHT LEFT DOWN  ]

;for 2/3 gray shade
;gray_total_count equ 5
;gray_split_count equ 3

;for 1/2 gray shade
gray_total_count equ 3
gray_split_count equ 2

gray_install:
        ld hl,gray_int          ;load interrupt routine
        ld de,$f5f5
        ld bc,gray_bottom-gray_top
        ldir
        ld hl,$f400             ;load ptr table
        ld de,$f401
        ld bc,256
        ld (hl),$f5
        ldir
        ld hl,$f501             ;clear key table
        ld de,$f502
        ld bc,8
        ld (hl),0
        ldir
        di
        exx
        ld c,gray_total_count
        ld de,$3c30
        exx
        ld a,$f4
        ld i,a
        im 2
        ei
        ret

gray_remove:
        di
        im 1
        ld a,$3c
        out (0),a
        ei
        ret

gray_int:

gray_top:
        ex af,af'
        exx
        in a,(3)
        bit 0,a         ;has on been pressed?
        jr nz,gray_shutdown ;yeah, kill the program
        bit 1,a         ;200/s interrupt
        jr z,gray_end
gray_cancel_shutdown:
        ld hl,($f508)
        inc hl
        ld ($f508),hl
        dec c           ;c=frame counter
        jr nz,gray_noreset
        ld c,gray_total_count
gray_noreset:
        ld a,c
        cp gray_split_count
        jr c,gray_doliteframe
        ld a,d
        jr gray_doframe
gray_doliteframe:
        ld a,e
gray_doframe:
        out (0),a       ;set visible frame
        ld a,$fe
        push de
        ld hl,$f501
        ld b,7
gray_checkkeys:
        ld d,b
        ld e,a
        call gray_checkrow
        xor $ff
        ld (hl),a
        ld a,e
        ld b,d
        inc hl
        rlca
        djnz gray_checkkeys
        pop de
        in a,(3)
        and $01
        add a,9
        out (3),a
gray_end:
        ld a,$b
        out (3),a
        exx
        ex af,af'
        ei
        reti

gray_shutdown:
        bit 3,a
        jr z,gray_cancel_shutdown
        im 1
        ld a,$3c
        out (0),a
        ld a,$a
        out (3),a
        inc a
        out (3),a
        ex af,af'
        exx
        ei
        jp $409c        ;jforce
gray_bottom:

;this guy stays here.  identical to rom routine...
gray_checkrow:
        out (1),a       ;write key mask
        nop             ;wait for hardware
        nop
        nop
        nop
        in a,(1)
        ld b,a
        ld a,$ff
        out (1),a       ;tell hardware to go back to sleep
        ld a,b
        ret
